Package org.opentcs.data.model

# Class TCSResource<E extends TCSResource<E>>

java.lang.Object
org.opentcs.data.TCSObject<E>
org.opentcs.data.model.TCSResource<E>

Type Parameters:
  `E` - The actual resource class.

All Implemented Interfaces:
  `java.io.Serializable`

Direct Known Subclasses:
  `Block`, `Location`, `Path`, `Point`

    public abstract class TCSResource<E extends TCSResource<E>>
    extends TCSObject<E>
    implements java.io.Serializable

Describes a resource that `Vehicle`s may claim for exclusive usage.

See Also:
  `Scheduler`, Serialized Form

- ## Field Summary

  ### Fields inherited from class org.opentcs.data.TCSObject

  `reference`

- ## Constructor Summary

  Constructors
  Modifier | Constructor | Description
  --- | --- | ---
  `protected` | `TCSResource​(java.lang.String name)` | Creates a new TCSResource.
  `protected` | `TCSResource​(java.lang.String name, java.util.Map<java.lang.String,​java.lang.String> properties, ObjectHistory history)` | Creates a new TCSResource.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `TCSResourceReference<E>` | `getReference()` | Returns a transient/soft reference to this object.

  ### Methods inherited from class org.opentcs.data.TCSObject

  `equals, getHistory, getName, getProperties, getProperty, hashCode, listWithoutNullValues, mapWithoutNullValues, propertiesWith, setWithoutNullValues, toString, withHistory, withHistoryEntry, withProperties, withProperty`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### TCSResource

    protected TCSResource​(java.lang.String name)
    Creates a new TCSResource.
    Parameters:
      `name` - The new resource's name.

  - ### TCSResource

    protected TCSResource​(java.lang.String name, java.util.Map<java.lang.String,​java.lang.String> properties, ObjectHistory history)
    Creates a new TCSResource.
    Parameters:
      `name` - The new resource's name.
      `properties` - A set of properties (key-value pairs) associated with this object.
      `history` - A history of events related to this object.

- ## Method Details

  - ### getReference

    public TCSResourceReference<E> getReference()
    Description copied from class: `TCSObject`
    Returns a transient/soft reference to this object.
    Overrides:
      `getReference` in class `TCSObject<E extends TCSResource<E>>`
    Returns:
      A transient/soft reference to this object.